#include "GrColors.h"

struct ColorSet {
	ofColor color;
	string name;
};

const ColorSet colorSets[NUM_COLOR_SET] = {
	/** 2colors set1 **/
	{ ofColor(132, 176, 185), "COLOR_COOL_2C_DARK_BLUE" },
	{ ofColor( 58, 106, 116), "COLOR_COOL_2C_DARK_BLUE" },
	/** { 2colors set2 **/
	{ ofColor( 81, 173, 166), "COLOR_COOL_2C_GREEN" },
	{ ofColor(108, 194, 175), "COLOR_COOL_2C_GREEN" },
	/** 2colors set3 **/
	{ ofColor(102,  78, 145), "COLOR_COOL_2C_PURPLE" },
	{ ofColor(139, 119, 169), "COLOR_COOL_2C_PURPLE" },
	/** 2colors set4 **/
	{ ofColor(128, 124, 171), "COLOR_COOL_2C_BLUE" },
	{ ofColor(124, 155, 193), "COLOR_COOL_2C_BLUE" },
	
	/** 3colors set1 **/
	{ ofColor(191, 208, 203), "COLOR_COOL_3C_DARK_BLUE" },
	{ ofColor(132, 176, 185), "COLOR_COOL_3C_DARK_BLUE" },
	{ ofColor( 58, 106, 116), "COLOR_COOL_3C_DARK_BLUE" },
	/** 3colors set2 **/
	{ ofColor( 81, 173, 166), "COLOR_COOL_3C_GREEN" },
	{ ofColor(108, 194, 175), "COLOR_COOL_3C_GREEN" },
	{ ofColor(165, 213, 195), "COLOR_COOL_3C_GREEN" },
	/** 3colors set3 **/
	{ ofColor(102,  78, 145), "COLOR_COOL_3C_PURPLE" },
	{ ofColor(120,  98, 156), "" },
	{ ofColor(139, 119, 169), "" },
	/** 3colors set4 **/
	{ ofColor(128, 124, 171), "COLOR_COOL_3C_BLUE" },
	{ ofColor(124, 155, 193), "" },
	{ ofColor(191, 226, 248), "" },

	/** 4colors set1 **/
	{ ofColor(141, 206, 228), "COLOR_COOL_4C_DARK_BLUE" },
	{ ofColor(124, 155, 193), "" },
	{ ofColor(128, 124, 171), "" },
	{ ofColor(102,  78, 145), "" },
	/** 4colors set2 **/
	{ ofColor(235, 245, 253), "COLOR_COOL_4C_GREEN" },
	{ ofColor(191, 226, 248), "" },
	{ ofColor(141, 206, 228), "" },
	{ ofColor(124, 155, 193), "" },
	/** 4colors set3 **/
	{ ofColor( 81, 173, 166), "COLOR_COOL_4C_PURPLE" },
	{ ofColor(  0, 134, 248), "" },
	{ ofColor(  0, 120, 131), "" },
	{ ofColor( 14,  59,  74), "" },
	/** 4colors set4 **/
	{ ofColor(213, 233, 215), "COLOR_COOL_4C_BLUE" },
	{ ofColor(165, 213, 195), "" },
	{ ofColor( 81, 173, 166), "" },
	{ ofColor(  0, 124, 131), "" },
	
	/** pp8.0 4colors quiet set1 **/
	{ ofColor(139, 119, 169), "COLOR_COOL_4C_QUIET_PURPLE1" },
	{ ofColor(120,  98, 156), "" },
	{ ofColor( 93,  53, 121), "" },
	{ ofColor( 71,  43,  71), "" },

	/** pp8.0 4colors quiet set2 **/
	{ ofColor(196, 187, 208), "COLOR_COOL_4C_QUIET_PURPLE2" },
	{ ofColor(157, 141, 181), "" },
	{ ofColor(120,  98, 156), "" },
	{ ofColor( 93,  53, 121), "" },

	/** pp8.0 4colors quiet set3 **/
	{ ofColor(132, 176, 185), "COLOR_COOL_4C_QUIET_BLUE1" },
	{ ofColor( 79, 123, 138), "" },
	{ ofColor( 58, 106, 116), "" },
	{ ofColor( 67,  87,  94), "" },

	/** pp8.0 4colors quiet set3 **/
	{ ofColor(191, 208, 203), "COLOR_COOL_4C_QUIET_BLUE2" },
	{ ofColor(132, 176, 185), "" },
	{ ofColor( 58, 106, 116), "" },
	{ ofColor( 67,  67,  66), "" },
};


const ofColor colorSet[NUM_COLOR_SET] = {
/**
 * Color Index 74 (book)
 * quiet color Cool View
 */
	/** 2colors set1 **/
	ofColor(132, 176, 185),
	ofColor( 58, 106, 116),
	/** 2colors set2 **/
	ofColor( 81, 173, 166),
	ofColor(108, 194, 175),
	/** 2colors set3 **/
	ofColor(102,  78, 145),
	ofColor(139, 119, 169),
	/** 2colors set4 **/
	ofColor(128, 124, 171),
	ofColor(124, 155, 193),
	
	/** 3colors set1 **/
	ofColor(191, 208, 203),
	ofColor(132, 176, 185),
	ofColor( 58, 106, 116),
	/** 3colors set2 **/
	ofColor( 81, 173, 166),
	ofColor(108, 194, 175),
	ofColor(165, 213, 195),
	/** 3colors set3 **/
	ofColor(102,  78, 145),
	ofColor(120,  98, 156),
	ofColor(139, 119, 169),
	/** 3colors set4 **/
	ofColor(128, 124, 171),
	ofColor(124, 155, 193),
	ofColor(191, 226, 248),

	/** 4colors set1 **/
	ofColor(141, 206, 228),
	ofColor(124, 155, 193),
	ofColor(128, 124, 171),
	ofColor(102,  78, 145),
	/** 4colors set2 **/
	ofColor(235, 245, 253),
	ofColor(191, 226, 248),
	ofColor(141, 206, 228),
	ofColor(124, 155, 193),
	/** 4colors set3 **/
	ofColor( 81, 173, 166),
	ofColor(  0, 134, 248),
	ofColor(  0, 120, 131),
	ofColor( 14,  59,  74),
	/** 4colors set4 **/
	ofColor(213, 233, 215),
	ofColor(165, 213, 195),
	ofColor( 81, 173, 166),
	ofColor(  0, 124, 131),
	
	/** pp8.0 4colors quiet set1 **/
	ofColor(139, 119, 169),
	ofColor(120,  98, 156),
	ofColor( 93,  53, 121),
	ofColor( 71,  43,  71),

	/** pp8.0 4colors quiet set2 **/
	ofColor(196, 187, 208),
	ofColor(157, 141, 181),
	ofColor(120,  98, 156),
	ofColor( 93,  53, 121),

	/** pp8.0 4colors quiet set3 **/
	ofColor(132, 176, 185),
	ofColor( 79, 123, 138),
	ofColor( 58, 106, 116),
	ofColor( 67,  87,  94),

	/** pp8.0 4colors quiet set3 **/
	ofColor(191, 208, 203),
	ofColor(132, 176, 185),
	ofColor( 58, 106, 116),
	ofColor( 67,  67,  66)
};

