#ifndef __GR_TEXT_AREA__
#define __GR_TEXT_AREA__

#include "GrMain.h"
#include "GrColors.h"

/**
 * @brief TextArea
 * @description デバッグ用のテキストエリア
 * @note 
 */
class TextArea : public GrDrawer {
public:
	TextArea(const int x, const int y, const int lineFeedWidth,
			 const ofColor &color, unsigned int numTextLine = 5);
	void draw();
	void addTextLine(string str);
	
private:
	int _x, _y, _linefeedWidth;
	ofColor textColor;
	vector<string> textLines;
	unsigned int numTextLine;
	ofMutex mutex;
};

extern TextArea *textArea;

#endif // __GR_TEXT_AREA__



